Name:           beagle
Version:        0.2.16
Release:        1%{?dist}
Summary:        The Beagle Search Infrastructure
Group:          User Interface/Desktops
License:        LGPL
URL:            http://beagle-project.org/
Source0:        %{name}-%{version}.tar.bz2
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  mono-devel
BuildRequires:  mono-data mono-data-sqlite
BuildRequires:  gtk-sharp2-gapi gtk-sharp2-devel gnome-sharp-devel mono-web zip libexif-devel
BuildRequires:  gsf-sharp-devel >= 0.6
BuildRequires:  sqlite-devel > 3.3.1
BuildRequires:  gmime-sharp >= 2.1.19
BuildRequires:  evolution-sharp-devel >= 0.10.2-3
BuildRequires:  libXScrnSaver-devel
BuildRequires:  gnome-vfs2-devel
BuildRequires:  libgnome-devel
BuildRequires:  gtk2-devel >= 2.6.0
BuildRequires:  librsvg2-devel >= 2.0
BuildRequires:	pygtk2-devel
BuildRequires:	python-devel
BuildRequires:	libXt-devel
BuildRequires:	gettext
BuildRequires:	autoconf
BuildRequires:	perl-XML-Parser
Requires: sqlite >= 3.3.1
Requires: mono-core >= 1.1.13.5
Requires: zip unzip sed grep poppler-utils
Requires: libbeagle

# 4.0.17-5 fixes bug #201991
Requires(pre):  shadow-utils >= 4.0.17-5

Patch2: beagle-0.2.7-crawl.patch
Patch3: beagle-0.2.1-spew.patch
Patch4: beagle-0.2.7-beagle-index-username.patch
Patch5: beagle-0.2.15.1-runuser.patch
Patch6: beagle-0.2.15.1-libdir.patch
Patch8: beagle-0.2.10-xconnection-exit-2.patch
Patch9: beagle-0.2.16-build-fix.patch

# Mono only available on these:
ExclusiveArch: %ix86 x86_64 ppc ia64 armv4l sparc
# no mono on s390 for now: s390 s390x 

# Firefox location info, for the beagle firefox plugin
%if "%{_libdir}" == "/usr/lib64"
%define grefile /etc/gre.d/gre64.conf
%else
%define grefile /etc/gre.d/gre.conf
%endif

%description
A general infrastructure for making your data easy to find. 

%package gui
Summary:      Beagle search system user interface
Group:        User Interface/Desktops
Requires:     beagle = %{version}-%{release}

%description gui
User interface for doing beagle searches

%package evolution
Summary:      Beagle backend for evolution
Group:        User Interface/Desktops
Requires:     beagle-gui = %{version}-%{release}

%description evolution
Beagle indexing backend for evolution

%package -n libbeagle
Summary:      Beagle C interface
Group:        Development/Libraries

%description -n libbeagle
Library to talk to the beagle server in C.

%package -n libbeagle-devel
Summary:      Beagle C interface
Group:        Development/Libraries
Requires:     libbeagle = %{version}-%{release} libxml2-devel glib2-devel
Requires:     pkgconfig

%description -n libbeagle-devel
Library to talk to the beagle server in C.

%package -n libbeagle-python
Summary:      Beagle python interface
Group:        Development/Libraries
Requires:     libbeagle = %{version}-%{release}
Requires:     python

%description -n libbeagle-python
Python wrappers for libbeagle

%prep
%setup -q
%patch2 -p1 -b .crawl
%patch3 -p1 -b .spew
%patch4 -p1 -b .beagleidx
%patch5 -p1 -b .runuser
%patch6 -p1 -b .libdir
%patch8 -p1 -b .xconnection-exit
%patch9 -p1 -b .build-fix

%build
autoconf
export MONO_SHARED_DIR=%{_builddir}/%{?buildsubdir}
%configure --enable-wv1
make %{?_smp_mflags}

# Generate the beagle.xpi for mozilla/firefox
pushd .
cd mozilla-extension
make
popd

%install
rm -rf $RPM_BUILD_ROOT
export MONO_SHARED_DIR=%{_builddir}/%{?buildsubdir}

make install DESTDIR=$RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT/var/cache/beagle/indexes

# Add an autostart file so beagled gets run by default
# (temporarily disabled)
mkdir -p $RPM_BUILD_ROOT/etc/xdg/autostart

# TODO: Isn't there a better place to install this?
install -m 644 mozilla-extension/beagle.xpi $RPM_BUILD_ROOT%{_libdir}/beagle/

desktop-file-install --vendor gnome --delete-original		\
  --dir $RPM_BUILD_ROOT%{_datadir}/applications			\
  --add-category X-Red-Hat-Base					\
  --add-only-show-in=GNOME                                      \
  $RPM_BUILD_ROOT%{_datadir}/applications/beagle-search.desktop

desktop-file-install --vendor gnome --delete-original		\
  --dir $RPM_BUILD_ROOT%{_datadir}/applications			\
  --add-category X-Red-Hat-Base					\
  --remove-category Utility                                     \
  --add-only-show-in=GNOME                                      \
  $RPM_BUILD_ROOT%{_datadir}/applications/beagle-settings.desktop

echo "NoDisplay=true" >> $RPM_BUILD_ROOT%{_datadir}/applications/gnome-beagle-search.desktop

sed -i -e 's@Icon=tango-system-search@Icon=gnome-search-tool@' $RPM_BUILD_ROOT%{_datadir}/applications/gnome-beagle-search.desktop

%find_lang %{name}

rm -f $RPM_BUILD_ROOT%{_libdir}/beagle/*.la
rm -f $RPM_BUILD_ROOT%{_libdir}/beagle/*.a
rm -f $RPM_BUILD_ROOT%{_libdir}/*.la
rm -f $RPM_BUILD_ROOT%{_libdir}/*.a
rm -f $RPM_BUILD_ROOT%{_libdir}/python*/site-packages/*.a
rm -f $RPM_BUILD_ROOT%{_libdir}/python*/site-packages/*.la

chmod a+x $RPM_BUILD_ROOT%{_libdir}/beagle/*/*.dll
chmod a+x $RPM_BUILD_ROOT%{_libdir}/beagle/*.dll
chmod a+x $RPM_BUILD_ROOT%{_libdir}/beagle/*.exe

#Disable the Thunderbird backend for now (#205985)
rm -f $RPM_BUILD_ROOT%{_libdir}/beagle/Backends/ThunderbirdBackends.dll*

%post -n libbeagle -p /sbin/ldconfig

%postun -n libbeagle -p /sbin/ldconfig

%pre
%define beagle_user_uid 58
# Remove old username, we switched to an 8 char one
for x in $(cut -d: -f1 /etc/passwd) ; do if [ "$x" == "beagleindex" ]; then /usr/sbin/userdel beagleindex; break; fi; done
for x in $(cut -d: -f1 /etc/group) ; do if [ "$x" == "beagleindex" ]; then /usr/sbin/groupdel beagleindex; break; fi; done
/usr/sbin/groupadd -g %{beagle_user_uid} -r beaglidx 2> /dev/null || :
/usr/sbin/useradd -r -u %{beagle_user_uid} -s /sbin/nologin -c "User for Beagle indexing" -d /var/cache/beagle -g beaglidx beaglidx 2> /dev/null || :

%preun
if [ -f %{_libdir}/beagle/beagle-plugin-path ]; then
  old=`cat %{_libdir}/beagle/beagle-plugin-path`
  rm -rf $old
  rm -rf  %{_libdir}/beagle/beagle-plugin-path 
fi

%post 
if [ -f %{_libdir}/beagle/beagle-plugin-path ]; then
  old=`cat %{_libdir}/beagle/beagle-plugin-path`
  rm -rf $old
  rm -rf  %{_libdir}/beagle/beagle-plugin-path 
fi

# install the firefox extension
if [ -f %{grefile} ] ; then
  ffdir=$(cat %{grefile} | awk '/GRE_PATH/ { split($0,p,"="); print p[2] }')

  cd $ffdir/extensions
  mkdir beagle-extension
  unzip -q -d beagle-extension %{_libdir}/beagle/beagle.xpi
  id=`grep em:id beagle-extension/install.rdf | head -1 | sed -e 's/^ *//' -e "s/<[^<]*>//g" | tr -d "\n\r"`
  if [ -e "$id" ]; then
    rm -rf beagle-extension
  else
    mv beagle-extension "$id"
  fi

  echo "$ffdir/extensions/$id" >  %{_libdir}/beagle/beagle-plugin-path
fi

%clean
rm -rf $RPM_BUILD_ROOT

%triggerin -- firefox
if [ -f %{_libdir}/beagle/beagle-plugin-path ]; then
  old=`cat %{_libdir}/beagle/beagle-plugin-path`
  rm -rf $old
  rm -rf  %{_libdir}/beagle/beagle-plugin-path
fi

# install the firefox extension
if [ -f %{grefile} ] ; then
  ffdir=$(cat %{grefile} | awk '/GRE_PATH/ { split($0,p,"="); print p[2] }')

  cd $ffdir/extensions
  mkdir beagle-extension
  unzip -q -d beagle-extension %{_libdir}/beagle/beagle.xpi
  id=`grep em:id beagle-extension/install.rdf | head -1 | sed -e 's/^ *//' -e "s/<[^<]*>//g" | tr -d "\n\r"`
  if [ -e "$id" ]; then
    rm -rf beagle-extension
  else
    mv beagle-extension "$id"
  fi

  echo "$ffdir/extensions/$id" >  %{_libdir}/beagle/beagle-plugin-path
fi

%triggerun -- firefox
# uninstall the firefox extension
if [ $2 = 0 -a -f %{_libdir}/beagle/beagle-plugin-path ]; then
  old=`cat %{_libdir}/beagle/beagle-plugin-path`
  rm -rf $old
  rm -rf  %{_libdir}/beagle/beagle-plugin-path
fi

%files -f %{name}.lang
%defattr(-,root,root,-)
%doc COPYING README
%{_sysconfdir}/cron.daily/*
%{_sysconfdir}/beagle
%{_bindir}/beagle-config
%{_bindir}/beagled
%{_bindir}/beagle-exercise-file-system
%{_bindir}/beagle-extract-content
%{_bindir}/beagle-index-info
%{_bindir}/beagle-index-url
%{_bindir}/beagle-info
%{_bindir}/beagle-ping
%{_bindir}/beagle-query
%{_bindir}/beagle-shutdown
%{_bindir}/beagle-status
%{_sbindir}/*
%{_libdir}/pkgconfig/beagle*.pc
%dir %{_libdir}/beagle
%dir %{_libdir}/beagle/Filters
%dir %{_libdir}/beagle/Backends
%{_libdir}/beagle/BeagleDaemonLib.dll*
%{_libdir}/beagle/BeagleDaemonPlugins.dll*
%{_libdir}/beagle/Beagle.dll*
%{_libdir}/beagle/Util.dll*
%{_libdir}/beagle/BeagleDaemon.exe*
%{_libdir}/beagle/BuildIndex.exe*
%{_libdir}/beagle/DumpIndex.exe*
%{_libdir}/beagle/Config.exe*
%{_libdir}/beagle/ExerciseFileSystem.exe*
%{_libdir}/beagle/ExtractContent.exe*
%{_libdir}/beagle/IndexHelper.exe*
%{_libdir}/beagle/IndexWebContent.exe*
%{_libdir}/beagle/Info.exe*
%{_libdir}/beagle/ManageIndex.exe*
%{_libdir}/beagle/Query.exe*
%{_libdir}/beagle/Shutdown.exe*
%{_libdir}/beagle/beagled-index-helper
%{_libdir}/beagle/libbeagleglue*
%{_libdir}/beagle/Filters/*
#Disabled for now (#205985)
#%{_libdir}/beagle/Backends/ThunderbirdBackends.dll*
# firefox plugin:
%{_libdir}/beagle/beagle.xpi
%{_datadir}/beagle
%{_datadir}/pixmaps/*
%{_mandir}/*/*
%dir %attr(-,beaglidx,beaglidx) /var/cache/beagle
%dir %attr(-,beaglidx,beaglidx) /var/cache/beagle/indexes
%{_sysconfdir}/xdg/autostart/*

%files gui
%defattr(-, root, root)
%{_bindir}/beagle-imlogviewer
%{_bindir}/beagle-search
%{_bindir}/beagle-settings
%{_libdir}/beagle/Images.dll*
%{_libdir}/beagle/UiUtil.dll*
%{_libdir}/beagle/ImLogViewer.exe*
%{_libdir}/beagle/Search.exe*
%{_libdir}/beagle/Settings.exe*
%{_libdir}/beagle/libbeagleuiglue*
%{_datadir}/applications/*

%files evolution
%defattr(-, root, root)
%{_libdir}/beagle/Backends/EvolutionBackends.dll*

%files -n libbeagle
%defattr(-, root, root)
%{_libdir}/libbeagle.so.*

%files -n libbeagle-devel
%defattr(-, root, root)
%{_includedir}/libbeagle
%{_libdir}/libbeagle.so
%{_libdir}/pkgconfig/libbeagle*.pc

%files -n libbeagle-python
%{_libdir}/python*/site-packages/beagle.so

%changelog
* Thu Feb  8 2007 Alexander Larsson <alexl@redhat.com> - 0.2.16-1
- update to 0.2.16

* Mon Feb  5 2007 Alexander Larsson <alexl@redhat.com> - 0.2.15-1
- Update to 0.2.15

* Wed Dec  6 2006 Jeremy Katz <katzj@redhat.com> - 0.2.13-3
- rebuild for python 2.5

* Tue Nov 28 2006 Alexander Larsson <alexl@redhat.com> - 0.2.13-2.fc7
- Fix xconnection patch to be threadsafe (#212370)

* Wed Nov 22 2006 Alexander Larsson <alexl@redhat.com> - 0.2.13-1
- Update to 0.2.13
- Enable wv1 (word) support
- Update key patch

* Sat Nov  4 2006 Matthias Clasen <mclasen@redhat.com> 0.2.12-1
- Update to 0.2.12

* Thu Oct 12 2006 Christopher Aillon <caillon@redhat.com> 0.2.10-5
- Rebuild

* Thu Oct 12 2006 Christopher Aillon <caillon@redhat.com> 0.2.10-4
- Fix firefox plugin handling:
  - Stop using rpm -q in scriptlets because that's dumb
  - Clean up after ourselves on uninstalls of the trigger or self
  - Don't install 64bit plugin into 32bit firefox and vice versa

* Sun Oct 01 2006 Jesse Keating <jkeating@redhat.com> - 0.2.10-3
- rebuilt for unwind info generation, broken in gcc-4.1.1-21

* Wed Sep 20 2006 Alexander Larsson <alexl@redhat.com> - 0.2.10-2
- Actually exit when X dies

* Wed Sep 20 2006 Alexander Larsson <alexl@redhat.com> - 0.2.10-1
- Update to 0.2.10, remove backported fixes
- This is a bugfix update that fixes a variety of bad bugs
- No new features

* Wed Sep 13 2006 Alexander Larsson <alexl@redhat.com> - 0.2.9-4
- Disable thunderbird backend for now (#205985)

* Wed Sep 13 2006 Alexander Larsson <alexl@redhat.com> - 0.2.9-3
- Fix xdgmime cache slowdown problems by backporting a fix from cvs

* Wed Sep  6 2006 Alexander Larsson <alexl@redhat.com> - 0.2.9-2
- Fix some packaging guideline issues
- BuildRequire gsf-sharp-devel

* Sun Sep  3 2006 Matthias Clasen <mclasen@redhat.com> - 0.2.9-1
- Update to 0.2.9
- Drop obsolete patches
- Require pkgconfig in the -devel package

* Wed Aug 23 2006 Matthias Clasen <mclasen@redhat.com> - 0.2.8-3
- Fix a crash, patch from upstream cvs (#203519)

* Tue Aug 22 2006 Alexander Larsson <alexl@redhat.com> - 0.2.8-2
- Backport cvs indexing performance fix

* Fri Aug 18 2006 Alexander Larsson <alexl@redhat.com> - 0.2.8-1
- Update to 0.2.8
- Rebuild with new mono and gtk-sharp2

* Tue Aug 15 2006 Matthias Clasen <mclasen@redhat.com> - 0.2.7-9.fc6
- Hide keybinding in beagle-settings, since the global
  search keybinding works.  (#201424)

* Fri Aug 11 2006 Alexander Larsson <alexl@redhat.com> - 0.2.7-8
- Split out gui and evolution
- Pre-require shadow-utils that fixes the group bug

* Thu Aug 10 2006 Alexander Larsson <alexl@redhat.com> - 0.2.7-7
- pre-require shadow-utils (#201991)

* Wed Jul 26 2006 Alexander Larsson <alexl@redhat.com> - 0.2.7-6
- Pass --autostarted in autostart desktop file to make autostart switch work

* Mon Jul 24 2006 Ray Strode <rstrode@redhat.com> - 0.2.7-5
- reenable beagle by default 

* Thu Jul 20 2006 Jesse Keating <jkeating@redhat.com> - 0.2.7-4
- Only remove beagleindex user/group if they exist (#196665)

* Fri Jul 14 2006 Matthias Clasen <mclasen@redhat.com> - 0.2.7-3
- Make beagle_util_daemon_is_running work with NFS homedirs

* Wed Jul 12 2006 Jesse Keating <jkeating@redhat.com> - 0.2.7-2.1
- rebuild

* Thu Jun 22 2006 Alexander Larsson <alexl@redhat.com> - 0.2.7-2
- Rebuild to pick up new gsf-sharp

* Wed Jun 21 2006 Alexander Larsson <alexl@redhat.com> - 0.2.7-1
- update to 0.2.7
- Use runuser, not su in index cronjob (#195809)
- Rename beagleindex to beaglidx (#184157)
- Remove --debug from all wrappers

* Thu Jun 16 2006 Ray Strode <rstrode@redhat.com> - 0.2.6-6
- add bug spew when debugging is enabled (bug 195621)

* Fri Jun  9 2006 Alexander Larsson <alexl@redhat.com> - 0.2.6-5
- Disable on s390* as mono doesn't build on s390 atm
- buildrequire gettext

* Thu May 25 2006 Nalin Dahyabhai <nalin@redhat.com> - 0.2.6-4
- rebuild

* Wed May 17 2006 Brian Pepple <bdpepple@ameritech.net> - 0.2.6-3
- Add BR for python-devel, libXt-devel, & pygtk2-devel.

* Tue May  2 2006 Alexander Larsson <alexl@redhat.com> - 0.2.6-2
- Update to 0.2.6

* Fri Apr 21 2006 Alexander Larsson <alexl@redhat.com> - 0.2.5-3
- Update to 0.2.5
- Update patches

* Fri Apr  7 2006 Matthias Clasen <mclasen@redhat.com> 0.2.4-2
- Update to 0.2.4
- Update patches

* Tue Mar 21 2006 Alexander Larsson <alexl@redhat.com> 0.2.3-5
- Rebuild fc5 update in rawhide

* Tue Mar 21 2006 Alexander Larsson <alexl@redhat.com> - 0.2.3-4
- Remove more instances of wrapper scripts starting apps in cwd.
  Fixes bug #185981, and CVE-2006-1296

* Fri Mar 17 2006 Ray Strode <rstrode@redhat.com> - 0.2.3-3
- use /sbin/nologin instead of /bin/nologin for beagle user
  shell

* Fri Mar 17 2006 Ray Strode <rstrode@redhat.com> - 0.2.3-2
- use /bin/nologin instead of /bin/false for beagle user
  shell

* Fri Mar 17 2006 Ray Strode <rstrode@redhat.com> - 0.2.3-1
- Update to 0.2.3

* Wed Mar  8 2006 Ray Strode <rstrode@redhat.com> - 0.2.2-3
- turn off beagle by default to limit the severity of
  bug 183898
- fix trigger/post scriptlet (bug 184238) 

* Tue Mar  7 2006 Alexander Larsson <alexl@redhat.com> - 0.2.2-2
- Fix beagle-craw-system NullPtrException

* Tue Mar  7 2006 Alexander Larsson <alexl@redhat.com> - 0.2.2-1
- update to 0.2.2

* Fri Mar  3 2006 Alexander Larsson <alexl@redhat.com> 0.2.1-17
- Change beagle user to uid/gid 58 (registered), because
  nut was already using 57 (unregistred!)

* Wed Mar  1 2006 Matthias Clasen <mclasen@redhat.com> 0.2.1-15
- Bump log level to "error" to avoid tons of
  pointless warnings. (#183162)

* Wed Mar  1 2006 Matthias Clasen <mclasen@redhat.com> 0.2.1-14
- Fix a typo in /etc/beagle/crawl-applications

* Wed Mar  1 2006 Ray Strode <rstrode@redhat.com> 0.2.1-13
- add patch from  Felipe Alfaro Solana <felipe_alfaro@linuxmail.org>
  to invote beagle indexing helper function with valid shell
  (bug 183360)

* Fri Feb 24 2006 Matthias Clasen <mclasen@redhat.com> 0.2.1-12
- Remove more "run from ." nonsense  (#182709)
- Don't spew tons of debug output  (#182660)
- Try to make the trigger more robust  (#182679)

* Wed Feb 22 2006 Matthias Clasen <mclasen@redhat.com> 0.2.1-11
- Silence %%post 

* Wed Feb 22 2006 Matthias Clasen <mclasen@redhat.com> 0.2.1-10
- Fix %%post for 64bit arches

* Tue Feb 21 2006 Matthias Clasen <mclasen@redhat.com> 0.2.1-8
- Autostart beagled by default
- Use anacron
- Install the firefox extension
- Add a trigger to reinstall the firefox extension 
  on firefox updates
- Adapt crawl-rules to Fedora

* Fri Feb 17 2006 Karsten Hopp <karsten@redhat.de> 0.2.1-7
- add BuildRequires

* Wed Feb 15 2006 Alexander Larsson <alexl@redhat.com> 0.2.1-6
- Make all dlls executable to correctly pick up dependencies

* Mon Feb 13 2006 Ray Strode <rstrode@redhat.com> - 0.2.1-4
- remove preferences from accessories menu
- hide holmes (gnome-panel shows it in places now)
- change holmes icon to one we have

* Sun Feb 12 2006 Christopher Aillon <caillon@redhat.com> - 0.2.1-4
- Update sqlite3.patch so that it behaves better with sqlite2 and 3

* Fri Feb 10 2006 Alexander Larsson <alexl@redhat.com> - 0.2.1-3
- Correctly allocate uid/gid

* Tue Feb  7 2006 Matthias Clasen <mclasen2redhat.com> - 0.2.1-2
- Add missing BuildRequires (#180336)

* Tue Feb 07 2006 Jesse Keating <jkeating@redhat.com> - 0.2.1-1.1
- rebuilt for new gcc4.1 snapshot and glibc changes

* Tue Jan 31 2006 Christopher Aillon <caillon@redhat.com> 0.2.1-1
- Update to beagle 0.2.1
- Use sqlite3 instead of sqlite2

* Tue Jan 31 2006 Ray Strode <rstrode@redhat.com> 0.2.0-4 
- don't blindly run beagled in current working directory 
  (bug 177675)

* Tue Jan 24 2006 Than Ngo <than@redhat.com> 0.2.0-3 
- added --add-only-show-in=gnome to the desktop-file-install calls
 
* Tue Jan 24 2006 Than Ngo <than@redhat.com> 0.2.0-2
- beagle-settings/beagle-search only show in gnome

* Sun Jan 22 2006 Alexander Larsson <alexl@redhat.com> - 0.2.0-1
- update to 0.2.0

* Wed Jan 18 2006 Ray Strode <rstrode@redhat.com> - 0.1.4-4
- depend on poppler for pdf utilities instead of xpdf 
  (bug 177446)

* Wed Jan 11 2006 Alexander Larsson <alexl@redhat.com> - 0.1.4-3
- Rebuild with fixed evolution-sharp

* Mon Jan  9 2006 Alexander Larsson <alexl@redhat.com> - 0.1.4-2
- Don't package libbeagle twice

* Mon Jan  9 2006 Alexander Larsson <alexl@redhat.com> - 0.1.4-1
- Update to 0.1.4
- Add mono 1.1.12.1 patch

* Fri Dec 09 2005 Jesse Keating <jkeating@redhat.com>
- rebuilt

* Thu Dec  8 2005 Alexander Larsson <alexl@redhat.com> - 0.1.3-1
- update to 0.1.3

* Wed Nov 23 2005 Alexander Larsson <alexl@redhat.com> - 0.1.2-2
- Fix evolution backend library loading

* Fri Nov 18 2005 Alexander Larsson <alexl@redhat.com> - 0.1.2-1
- Initial version
